Index: squid/src/cache_cf.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/cache_cf.c,v
retrieving revision 1.4.2.13
retrieving revision 1.4.2.14
diff -u -r1.4.2.13 -r1.4.2.14
--- squid/src/cache_cf.c	1 Jul 2007 08:34:23 -0000	1.4.2.13
+++ squid/src/cache_cf.c	2 Jul 2007 07:36:52 -0000	1.4.2.14
@@ -1,6 +1,6 @@
 
 /*
- * $Id: cache_cf.c,v 1.4.2.13 2007/07/01 08:34:23 amosjeffries Exp $
+ * $Id: cache_cf.c,v 1.4.2.14 2007/07/02 07:36:52 amosjeffries Exp $
  *
  * DEBUG: section 3     Configuration File Parsing
  * AUTHOR: Harvest Derived
@@ -80,7 +80,6 @@
 };
 
 
-static void cbdataFree_http_port(void *data);
 static void update_maxobjsize(void);
 static void configDoConfigure(void);
 static void parse_refreshpattern(refresh_t **);
@@ -108,11 +107,11 @@
 static void dump_denyinfo(StoreEntry * entry, const char *name, acl_deny_info_list * var);
 static void free_denyinfo(acl_deny_info_list ** var);
 #if USE_WCCPv2
-static void parse_sockaddr_storage_list(sockaddr_storage_list **);
-static void dump_sockaddr_storage_list(StoreEntry *, const char *, const sockaddr_storage_list *);
-static void free_sockaddr_storage_list(sockaddr_storage_list **);
+static void parse_sockaddr_in_list(sockaddr_in_list **);
+static void dump_sockaddr_in_list(StoreEntry *, const char *, const sockaddr_in_list *);
+static void free_sockaddr_in_list(sockaddr_in_list **);
 #if UNUSED_CODE
-static int check_null_sockaddr_storage_list(const sockaddr_storage_list *);
+static int check_null_sockaddr_in_list(const sockaddr_in_list *);
 #endif
 #endif
 static void parse_http_port_list(http_port_list **);
@@ -755,43 +754,31 @@
 }
 
 static void
-dump_address(StoreEntry * entry, const char *name, struct sockaddr *addr)
+dump_address(StoreEntry * entry, const char *name, struct in_addr addr)
 {
-    storeAppendPrintf(entry, "%s %s\n", name, sockaddr_ntoa(addr));
+    storeAppendPrintf(entry, "%s %s\n", name, inet_ntoa(addr));
 }
 
 static void
-parse_address(struct sockaddr *addr)
+parse_address(struct in_addr *addr)
 {
-    struct addrinfo hints, *res, *res0;
-    int error;
+    const struct hostent *hp;
     char *token = strtok(NULL, w_space);
 
     if (token == NULL)
 	self_destruct();
     if (safe_inet_addr(token, addr) == 1)
 	(void) 0;
-    else {
-	memset(&hints, 0, sizeof(hints));
-	hints.ai_family = PF_UNSPEC;
-	hints.ai_flags = AI_PASSIVE;
-	error = getaddrinfo(token, NULL, &hints, &res);
-	if (error)
-	    self_destruct();
-	for (res = res0; res; res = res->ai_next) {
-	    if ((res->ai_family == AF_INET) || (res->ai_family == AF_INET6)) {
-		xmemcpy(addr, res->ai_addr, SOCKLEN(res->ai_addr));
-		break;
-	    }
-	}
-	freeaddrinfo(res0);
-    }
+    else if ((hp = gethostbyname(token)))	/* dont use ipcache */
+	*addr = inaddrFromHostent(hp);
+    else
+	self_destruct();
 }
 
 static void
-free_address(struct sockaddr *addr)
+free_address(struct in_addr *addr)
 {
-    memset(addr, '\0', SOCKLEN(addr));
+    memset(addr, '\0', sizeof(struct in_addr));
 }
 
 CBDATA_TYPE(acl_address);
@@ -801,8 +788,10 @@
 {
     acl_address *l;
     for (l = head; l; l = l->next) {
-	storeAppendPrintf(entry, "%s %s", name, sockaddr_ntoa(&l->addr));
-/*	storeAppendPrintf(entry, "%s autoselect", name);	*/
+	if (l->addr.s_addr != INADDR_ANY)
+	    storeAppendPrintf(entry, "%s %s", name, inet_ntoa(l->addr));
+	else
+	    storeAppendPrintf(entry, "%s autoselect", name);
 	dump_acl_list(entry, l->acl_list);
 	storeAppendPrintf(entry, "\n");
     }
@@ -2646,20 +2635,19 @@
 
 #if USE_WCCPv2
 static void
-parse_sockaddr_storage_list(sockaddr_storage_list ** head)
+parse_sockaddr_in_list(sockaddr_in_list ** head)
 {
     char *token;
     char *t;
     char *host;
     char *tmp;
-    struct addrinfo hints, *res, *res0;
+    const struct hostent *hp;
     unsigned short port = 0;
-    sockaddr_storage_list *s;
-    int error;
+    sockaddr_in_list *s;
     while ((token = strtok(NULL, w_space))) {
 	host = NULL;
 	port = 0;
-	if ((t = strrchr(token, ':'))) {
+	if ((t = strchr(token, ':'))) {
 	    /* host:port */
 	    host = token;
 	    *t = '\0';
@@ -2673,27 +2661,15 @@
 	    port = 0;
 	}
 	s = xcalloc(1, sizeof(*s));
-	if (safe_inet_addr(token, &s->s) == 1)
+	s->s.sin_port = htons(port);
+	if (NULL == host)
+	    s->s.sin_addr = any_addr;
+	else if (1 == safe_inet_addr(host, &s->s.sin_addr))
 	    (void) 0;
-	else {
-	    memset(&hints, 0, sizeof(hints));
-	    hints.ai_family = PF_UNSPEC;
-	    hints.ai_flags = AI_PASSIVE;
-	    error = getaddrinfo(token, NULL, &hints, &res);
-	    if (error)
-		self_destruct();
-	    for (res = res0; res; res = res->ai_next) {
-		if ((res->ai_family == AF_INET) || (res->ai_family == AF_INET6)) {
-		    xmemcpy(&s->s, res->ai_addr, SOCKLEN(res->ai_addr));
-		    break;
-		}
-	    }
-	    freeaddrinfo(res0);
-	}
-	if (s->s.ss_family == AF_INET6)
-	    ((struct sockaddr_in6 *)&s->s)->sin6_port = htons(port);
+	else if ((hp = gethostbyname(host)))	/* dont use ipcache */
+	    s->s.sin_addr = inaddrFromHostent(hp);
 	else
-	    ((struct sockaddr_in *)&s->s)->sin_port = htons(port);
+	    self_destruct();
 	while (*head)
 	    head = &(*head)->next;
 	*head = s;
@@ -2701,23 +2677,21 @@
 }
 
 static void
-dump_sockaddr_storage_list(StoreEntry * e, const char *n, const sockaddr_storage_list * s)
+dump_sockaddr_in_list(StoreEntry * e, const char *n, const sockaddr_in_list * s)
 {
     while (s) {
 	storeAppendPrintf(e, "%s %s:%d\n",
 	    n,
-	    sockaddr_ntoa(&s->s),
-	    s->s.ss_family == AF_INET6 ?
-		ntohs(((struct sockaddr_in6 *)&s->s)->sin6_port) :
-		ntohs(((struct sockaddr_in *)&s->s)->sin_port)); 
+	    inet_ntoa(s->s.sin_addr),
+	    ntohs(s->s.sin_port));
 	s = s->next;
     }
 }
 
 static void
-free_sockaddr_storage_list(sockaddr_storage_list ** head)
+free_sockaddr_in_list(sockaddr_in_list ** head)
 {
-    sockaddr_storage_list *s;
+    sockaddr_in_list *s;
     while ((s = *head) != NULL) {
 	*head = s->next;
 	xfree(s);
@@ -2726,7 +2700,7 @@
 
 #if UNUSED_CODE
 static int
-check_null_sockaddr_storage_list(const sockaddr_storage_list * s)
+check_null_sockaddr_in_list(const sockaddr_in_list * s)
 {
     return NULL == s;
 }
@@ -2736,64 +2710,32 @@
 static void
 parse_http_port_specification(http_port_list * s, char *token)
 {
-    CBDATA_TYPE(http_port_list);
     char *host = NULL;
-    char *portstr = NULL;
-    struct addrinfo hints, *res, *res0;
-    http_port_list *sn1, *sn2;
-    int error;
+    const struct hostent *hp;
     unsigned short port = 0;
     char *t;
-    CBDATA_INIT_TYPE_FREECB(http_port_list, cbdataFree_http_port);
-    if ((t = strrchr(token, ':'))) {
+    if ((t = strchr(token, ':'))) {
 	/* host:port */
-	port = xatos(t + 1);
-	portstr = t + 1;
 	host = token;
 	*t = '\0';
-	t--;
-	if (*t == ']') {
-	    *t = '\0';
-	    host = token+1;
-	}
+	port = xatos(t + 1);
     } else {
 	/* port */
 	port = xatos(token);
-	portstr = token;
     }
     if (port == 0)
 	self_destruct();
-
-    memset(&hints, 0, sizeof(hints));
-    if (!host) {
-	hints.ai_family = PF_UNSPEC;
-	hints.ai_socktype = SOCK_STREAM;
-	hints.ai_flags = AI_PASSIVE;
-    }
-    error = getaddrinfo(host, portstr, &hints, &res0);
-    if (error)
-	self_destruct();
-    sn1 = s;
-    sn2 = s;
-    for (res = res0; res; res = res->ai_next) {
-	if ((res->ai_family == AF_INET) ||(res->ai_family == AF_INET6)) {
-	    if (!sn2) {
-		sn2 = cbdataAlloc(http_port_list);
-		sn1->next = sn2;
-		sn1 = sn2;
-	    }
-	    xmemcpy(&sn2->s, res->ai_addr, SOCKLEN(res->ai_addr));
-	    if (res->ai_family == AF_INET6)
-		((struct sockaddr_in6 *)&sn2->s)->sin6_port = htons(port);
-	    else 
-		((struct sockaddr_in *)&sn2->s)->sin_port = htons(port);
-	    if (host)
-		sn2->defaultsite = xstrdup(host);
-	    sn2 = sn2->next;
-	}
-    }
-    freeaddrinfo(res0);
-
+    s->s.sin_port = htons(port);
+    if (NULL == host)
+	s->s.sin_addr = any_addr;
+    else if (1 == safe_inet_addr(host, &s->s.sin_addr))
+	(void) 0;
+    else if ((hp = gethostbyname(host))) {
+	/* dont use ipcache */
+	s->s.sin_addr = inaddrFromHostent(hp);
+	s->defaultsite = xstrdup(host);
+    } else
+	self_destruct();
 }
 
 static void
@@ -2812,9 +2754,7 @@
 	s->vhost = 1;
 	s->accel = 1;
     } else if (strcmp(token, "vport") == 0) {
-	s->vport = (s->s.ss_family == AF_INET6) ? 
-		ntohs(((struct sockaddr_in6 *)&s->s)->sin6_port) :
-		ntohs(((struct sockaddr_in *)&s->s)->sin_port);
+	s->vport = ntohs(s->s.sin_port);
 	s->accel = 1;
     } else if (strncmp(token, "vport=", 6) == 0) {
 	s->vport = xatos(token + 6);
@@ -2894,9 +2834,10 @@
 static void
 dump_generic_http_port(StoreEntry * e, const char *n, const http_port_list * s)
 {
-    char host[100], port[8];
-    getnameinfo((struct sockaddr *)&s->s, SOCKLEN(&s->s), host, 100, port, 8, NI_NUMERICHOST|NI_NUMERICSERV);
-    storeAppendPrintf(e, "%s %s:%s", n, host, port);
+    storeAppendPrintf(e, "%s %s:%d",
+	n,
+	inet_ntoa(s->s.sin_addr),
+	ntohs(s->s.sin_port));
     if (s->transparent)
 	storeAppendPrintf(e, " transparent");
     if (s->accel)
@@ -2905,8 +2846,7 @@
 	storeAppendPrintf(e, " defaultsite=%s", s->defaultsite);
     if (s->vhost)
 	storeAppendPrintf(e, " vhost");
-    if ( (s->s.ss_family == AF_INET6 && s->vport == ntohs(((struct sockaddr_in6 *)&s->s)->sin6_port) ) || 
-         (s->s.ss_family == AF_INET  && s->vport == ntohs(((struct sockaddr_in *)&s->s)->sin_port) )      )
+    if (s->vport == ntohs(s->s.sin_port))
 	storeAppendPrintf(e, " vport");
     else if (s->vport)
 	storeAppendPrintf(e, " vport=%d", s->vport);
Index: squid/src/cf.data.pre
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/cf.data.pre,v
retrieving revision 1.4.6.8
retrieving revision 1.4.6.9
diff -u -r1.4.6.8 -r1.4.6.9
--- squid/src/cf.data.pre	1 Jul 2007 05:44:18 -0000	1.4.6.8
+++ squid/src/cf.data.pre	2 Jul 2007 07:36:53 -0000	1.4.6.9
@@ -1,6 +1,6 @@
 
 #
-# $Id: cf.data.pre,v 1.4.6.8 2007/07/01 05:44:18 amosjeffries Exp $
+# $Id: cf.data.pre,v 1.4.6.9 2007/07/02 07:36:53 amosjeffries Exp $
 #
 # SQUID Web Proxy Cache          http://www.squid-cache.org/
 # ----------------------------------------------------------
@@ -384,26 +384,14 @@
 	By default, Squid doesn't listen on any multicast groups.
 DOC_END
 
-NAME: udp_incoming_address6
-TYPE: address*
-LOC:Config.Addrs.udp6_incoming
-DEFAULT: ::
-DOC_NONE
-
-NAME: udp_outgoing_address6
-TYPE: address*
-LOC:Config.Addrs.udp6_outgoing
-DEFAULT: ffff:ffff:ffff:ffff:ffff:ffff:ffff:ffff
-DOC_NONE
-
 NAME: udp_incoming_address
-TYPE: address*
+TYPE: address
 LOC:Config.Addrs.udp_incoming
 DEFAULT: 0.0.0.0
 DOC_NONE
 
 NAME: udp_outgoing_address
-TYPE: address*
+TYPE: address
 LOC: Config.Addrs.udp_outgoing
 DEFAULT: 255.255.255.255
 DOC_START
@@ -427,7 +415,6 @@
 	have the same value since they both use port 3130.
 DOC_END
 
-
 COMMENT_START
  OPTIONS WHICH AFFECT THE NEIGHBOR SELECTION ALGORITHM
  -----------------------------------------------------------------------------
@@ -1485,20 +1472,8 @@
 	browsing.
 DOC_END
 
-NAME: client_masklen
-TYPE: int
-LOC: Config.Addrs.client_masklen
-DEFAULT: 32
-DOC_NONE
-
-NAME: client6_masklen
-TYPE: int
-LOC: Config.Addrs.client6_masklen
-DEFAULT: 128
-DOC_NONE
-
 NAME: client_netmask
-TYPE: address*
+TYPE: address
 LOC: Config.Addrs.client_netmask
 DEFAULT: 255.255.255.255
 DOC_START
@@ -2824,10 +2799,10 @@
 
 NOCOMMENT_START
 #Recommended minimum configuration:
-acl all src 0.0.0.0/0 ::/0
+acl all src 0.0.0.0/0.0.0.0
 acl manager proto cache_object
-acl localhost src 127.0.0.1/32 ::1/128
-acl to_localhost dst 127.0.0.0/8 ::/126
+acl localhost src 127.0.0.1/255.255.255.255
+acl to_localhost dst 127.0.0.0/8
 acl SSL_ports port 443
 acl Safe_ports port 80		# http
 acl Safe_ports port 21		# ftp
@@ -3145,8 +3120,8 @@
 	Example where normal_service_net uses the TOS value 0x00
 	and normal_service_net uses 0x20
 
-	acl normal_service_net src 10.0.0.0/24
-	acl good_service_net src 10.0.1.0/24
+	acl normal_service_net src 10.0.0.0/255.255.255.0
+	acl good_service_net src 10.0.1.0/255.255.255.0
 	tcp_outgoing_tos 0x00 normal_service_net 0x00
 	tcp_outgoing_tos 0x20 good_service_net
 
@@ -3184,8 +3159,8 @@
 	source address 10.1.0.2 and the rest will be forwarded with
 	source address 10.1.0.3.
 
-	acl normal_service_net src 10.0.0.0/24
-	acl good_service_net src 10.0.1.0/24
+	acl normal_service_net src 10.0.0.0/255.255.255.0
+	acl good_service_net src 10.0.1.0/255.255.255.0
 	tcp_outgoing_address 10.0.0.1 normal_service_net
 	tcp_outgoing_address 10.0.0.2 good_service_net
 	tcp_outgoing_address 10.0.0.3
@@ -3614,13 +3589,13 @@
 COMMENT_END
 
 NAME: wccp_router
-TYPE: address*
+TYPE: address
 LOC: Config.Wccp.router
 DEFAULT: 0.0.0.0
 IFDEF: USE_WCCP
 DOC_NONE
 NAME: wccp2_router
-TYPE: sockaddr_storage_list
+TYPE: sockaddr_in_list
 LOC: Config.Wccp2.router
 DEFAULT: none
 IFDEF: USE_WCCPv2
@@ -3790,13 +3765,13 @@
 DOC_END
 
 NAME: wccp_address
-TYPE: address*
+TYPE: address
 LOC: Config.Wccp.address
 DEFAULT: 0.0.0.0
 IFDEF: USE_WCCP
 DOC_NONE
 NAME: wccp2_address
-TYPE: address*
+TYPE: address
 LOC: Config.Wccp2.address
 DEFAULT: 0.0.0.0
 IFDEF: USE_WCCPv2
@@ -4422,7 +4397,7 @@
 	requests, except those in your local domain use something like:
 
 		acl local-servers dstdomain .foo.net
-		acl all src 0.0.0.0/0 ::/0
+		acl all src 0.0.0.0/0.0.0.0
 		never_direct deny local-servers
 		never_direct allow all
 
@@ -4627,13 +4602,13 @@
 DOC_END
 
 NAME: snmp_incoming_address
-TYPE: address*
+TYPE: address
 LOC: Config.Addrs.snmp_incoming
 DEFAULT: 0.0.0.0
 IFDEF: SQUID_SNMP
 DOC_NONE
 NAME: snmp_outgoing_address
-TYPE: address*
+TYPE: address
 LOC: Config.Addrs.snmp_outgoing
 DEFAULT: 255.255.255.255
 IFDEF: SQUID_SNMP
@@ -4778,7 +4753,7 @@
 
 NAME: mcast_miss_addr
 IFDEF: MULTICAST_MISS_STREAM
-TYPE: address*
+TYPE: address
 LOC: Config.mcast_miss.addr
 DEFAULT: 255.255.255.255
 DOC_START
Index: squid/src/cf_gen.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/cf_gen.c,v
retrieving revision 1.3.6.5
retrieving revision 1.3.6.6
diff -u -r1.3.6.5 -r1.3.6.6
--- squid/src/cf_gen.c	1 Jul 2007 05:44:20 -0000	1.3.6.5
+++ squid/src/cf_gen.c	2 Jul 2007 07:36:53 -0000	1.3.6.6
@@ -1,6 +1,6 @@
 
 /*
- * $Id: cf_gen.c,v 1.3.6.5 2007/07/01 05:44:20 amosjeffries Exp $
+ * $Id: cf_gen.c,v 1.3.6.6 2007/07/02 07:36:53 amosjeffries Exp $
  *
  * DEBUG: none          Generate squid.conf.default and cf_parser.h
  * AUTHOR: Max Okumoto
@@ -85,7 +85,6 @@
     Line *doc;
     Line *nocomment;
     int array_flag;
-    int ptr_flag;
     struct Entry *next;
 } Entry;
 
@@ -216,12 +215,6 @@
 		    curr->array_flag = 1;
 		    *(ptr + strlen(ptr) - 2) = '\0';
 		}
-		/* hack to support pointers to struct */
-		curr->ptr_flag = 0;
-		if (0 == strcmp(ptr + strlen(ptr) - 1, "*")) {
-		    curr->ptr_flag = 1;
-		    *(ptr + strlen(ptr) - 1) = '\0';
-		}
 		curr->type = xstrdup(ptr);
 	    } else if (!strncmp(buff, "IFDEF:", 6)) {
 		if ((ptr = strtok(buff + 6, WS)) == NULL) {
@@ -528,10 +521,9 @@
 	    continue;
 	if (entry->ifdef)
 	    fprintf(fp, "#if %s\n", entry->ifdef);
-	fprintf(fp, "\tdump_%s(entry, \"%s\", %s%s);\n",
+	fprintf(fp, "\tdump_%s(entry, \"%s\", %s);\n",
 	    entry->type,
 	    entry->name,
-	    entry->ptr_flag ? "&" : "",
 	    entry->loc);
 	if (entry->ifdef)
 	    fprintf(fp, "#endif\n");
Index: squid/src/client_db.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/client_db.c,v
retrieving revision 1.4.6.6
retrieving revision 1.4.6.7
diff -u -r1.4.6.6 -r1.4.6.7
--- squid/src/client_db.c	1 Jul 2007 05:44:20 -0000	1.4.6.6
+++ squid/src/client_db.c	2 Jul 2007 07:36:53 -0000	1.4.6.7
@@ -1,6 +1,6 @@
 
 /*
- * $Id: client_db.c,v 1.4.6.6 2007/07/01 05:44:20 amosjeffries Exp $
+ * $Id: client_db.c,v 1.4.6.7 2007/07/02 07:36:53 amosjeffries Exp $
  *
  * DEBUG: section 0     Client Database
  * AUTHOR: Duane Wessels
@@ -36,7 +36,7 @@
 #include "squid.h"
 
 static hash_table *client_table = NULL;
-static ClientInfo *clientdbAdd(struct sockaddr *addr);
+static ClientInfo *clientdbAdd(struct in_addr addr);
 static FREE clientdbFreeItem;
 static void clientdbStartGC(void);
 static void clientdbScheduledGC(void *);
@@ -49,14 +49,12 @@
 #define CLIENT_DB_HASH_SIZE 467
 
 static ClientInfo *
-clientdbAdd(struct sockaddr *addr)
+clientdbAdd(struct in_addr addr)
 {
     ClientInfo *c;
-    char host[100];
-    getnameinfo(addr, SOCKLEN(addr), host, 100, NULL, 0, NI_NUMERICHOST);
     c = memAllocate(MEM_CLIENT_INFO);
-    c->hash.key = xstrdup(host);
-    xmemcpy(&c->addr, addr, SOCKLEN(addr));
+    c->hash.key = xstrdup(xinet_ntoa(addr));
+    c->addr = addr;
     hash_join(client_table, &c->hash);
     statCounter.client_http.clients++;
     if ((statCounter.client_http.clients > max_clients) && !cleanup_running && cleanup_scheduled < 2) {
@@ -79,13 +77,13 @@
 }
 
 void
-clientdbUpdate(struct sockaddr *addr, log_type ltype, protocol_t p, squid_off_t size)
+clientdbUpdate(struct in_addr addr, log_type ltype, protocol_t p, squid_off_t size)
 {
-    const char key[100];
+    const char *key;
     ClientInfo *c;
     if (!Config.onoff.client_db)
 	return;
-    getnameinfo(addr, SOCKLEN(addr), key, 100, NULL, 0, NI_NUMERICHOST);
+    key = xinet_ntoa(addr);
     c = (ClientInfo *) hash_lookup(client_table, key);
     if (c == NULL)
 	c = clientdbAdd(addr);
@@ -115,13 +113,13 @@
  * -1.  To get the current value, simply call with delta = 0.
  */
 int
-clientdbEstablished(struct sockaddr *addr, int delta)
+clientdbEstablished(struct in_addr addr, int delta)
 {
-    const char key[100];
+    const char *key;
     ClientInfo *c;
     if (!Config.onoff.client_db)
 	return 0;
-    getnameinfo(addr, SOCKLEN(addr), key, 100, NULL, 0, NI_NUMERICHOST);
+    key = xinet_ntoa(addr);
     c = (ClientInfo *) hash_lookup(client_table, key);
     if (c == NULL)
 	c = clientdbAdd(addr);
@@ -133,16 +131,16 @@
 
 #define CUTOFF_SECONDS 3600
 int
-clientdbCutoffDenied(struct sockaddr *addr)
+clientdbCutoffDenied(struct in_addr addr)
 {
-    const char key[100];
+    const char *key;
     int NR;
     int ND;
     double p;
     ClientInfo *c;
     if (!Config.onoff.client_db)
 	return 0;
-    getnameinfo(addr, SOCKLEN(addr), key, 100, NULL, 0, NI_NUMERICHOST);
+    key = xinet_ntoa(addr);
     c = (ClientInfo *) hash_lookup(client_table, key);
     if (c == NULL)
 	return 0;
@@ -186,7 +184,7 @@
     hash_first(client_table);
     while ((c = (ClientInfo *) hash_next(client_table))) {
 	storeAppendPrintf(sentry, "Address: %s\n", hashKeyStr(&c->hash));
-	storeAppendPrintf(sentry, "Name: %s\n", fqdnFromAddr(&c->addr));
+	storeAppendPrintf(sentry, "Name: %s\n", fqdnFromAddr(c->addr));
 	storeAppendPrintf(sentry, "Currently established connections: %d\n",
 	    c->n_established);
 	storeAppendPrintf(sentry, "    ICP Requests %d\n",
@@ -301,7 +299,6 @@
 }
 
 #if SQUID_SNMP
-/* XXX husni */
 struct in_addr *
 client_entry(struct in_addr *current)
 {
@@ -350,7 +347,7 @@
     switch (Var->name[LEN_SQ_NET + 2]) {
     case MESH_CTBL_ADDR:
 	Answer = snmp_var_new_integer(Var->name, Var->name_length,
-	    (snint) 0 /* c->addr.s_addr */,
+	    (snint) c->addr.s_addr,
 	    SMI_IPADDRESS);
 	break;
     case MESH_CTBL_HTBYTES:
